<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_installation_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnInstallationPractice".
 *
 * Columns in table "cpn_installation_practice" available as properties of the model,
 * followed by relations of table "cpn_installation_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $cpn_installation_id
 * @property integer $cpn_installation_location_id
 * @property integer $practice_id
 * @property integer $send_appointment_reminders
 * @property integer $avoid_app_within
 * @property integer $pre_appt_reminder_mail
 * @property integer $pre_appt_reminder_sms
 * @property integer $pre_appt_reminder_autocall
 * @property integer $pre_appt_reminder_staffcall
 * @property string $fb_page_id
 * @property string $date_reminder_agreement
 * @property string $copy_reminder_agreement
 * @property integer $account_reminder_agreement
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property Account $addedByAccount
 * @property CpnInstallation $cpnInstallation
 */
abstract class BaseCpnInstallationPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_installation_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnInstallationPractice|CpnInstallationPractices', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('cpn_installation_id, added_by_account_id', 'required'),
            array('cpn_installation_id, cpn_installation_location_id, practice_id, send_appointment_reminders, avoid_app_within, pre_appt_reminder_mail, pre_appt_reminder_sms, pre_appt_reminder_autocall, pre_appt_reminder_staffcall, account_reminder_agreement, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('fb_page_id', 'length', 'max' => 25),
            array('date_reminder_agreement, copy_reminder_agreement, date_added, date_updated', 'safe'),
            array('cpn_installation_location_id, practice_id, send_appointment_reminders, avoid_app_within, pre_appt_reminder_mail, pre_appt_reminder_sms, pre_appt_reminder_autocall, pre_appt_reminder_staffcall, fb_page_id, date_reminder_agreement, copy_reminder_agreement, account_reminder_agreement, date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, cpn_installation_id, cpn_installation_location_id, practice_id, send_appointment_reminders, avoid_app_within, pre_appt_reminder_mail, pre_appt_reminder_sms, pre_appt_reminder_autocall, pre_appt_reminder_staffcall, fb_page_id, date_reminder_agreement, copy_reminder_agreement, account_reminder_agreement, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnInstallation' => array(self::BELONGS_TO, 'CpnInstallation', 'cpn_installation_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'cpn_installation_id' => null,
            'cpn_installation_location_id' => Yii::t('app', 'Cpn Installation Location'),
            'practice_id' => Yii::t('app', 'Practice'),
            'send_appointment_reminders' => Yii::t('app', 'Send Appointment Reminders'),
            'avoid_app_within' => Yii::t('app', 'Avoid App Within'),
            'pre_appt_reminder_mail' => Yii::t('app', 'Pre Appt Reminder Mail'),
            'pre_appt_reminder_sms' => Yii::t('app', 'Pre Appt Reminder Sms'),
            'pre_appt_reminder_autocall' => Yii::t('app', 'Pre Appt Reminder Autocall'),
            'pre_appt_reminder_staffcall' => Yii::t('app', 'Pre Appt Reminder Staffcall'),
            'fb_page_id' => Yii::t('app', 'Fb Page'),
            'date_reminder_agreement' => Yii::t('app', 'Date Reminder Agreement'),
            'copy_reminder_agreement' => Yii::t('app', 'Copy Reminder Agreement'),
            'account_reminder_agreement' => Yii::t('app', 'Account Reminder Agreement'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'addedByAccount' => null,
            'cpnInstallation' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('cpn_installation_id', $this->cpn_installation_id);
        $criteria->compare('cpn_installation_location_id', $this->cpn_installation_location_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('send_appointment_reminders', $this->send_appointment_reminders);
        $criteria->compare('avoid_app_within', $this->avoid_app_within);
        $criteria->compare('pre_appt_reminder_mail', $this->pre_appt_reminder_mail);
        $criteria->compare('pre_appt_reminder_sms', $this->pre_appt_reminder_sms);
        $criteria->compare('pre_appt_reminder_autocall', $this->pre_appt_reminder_autocall);
        $criteria->compare('pre_appt_reminder_staffcall', $this->pre_appt_reminder_staffcall);
        $criteria->compare('fb_page_id', $this->fb_page_id, true);
        $criteria->compare('date_reminder_agreement', $this->date_reminder_agreement, true);
        $criteria->compare('copy_reminder_agreement', $this->copy_reminder_agreement, true);
        $criteria->compare('account_reminder_agreement', $this->account_reminder_agreement);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
